# A type of -*- python -*- file
# cython: language_level=3
import numpy as np
cimport numpy as np
cimport SubsurfaceTransportCoefficients as cppsstc

def calculateRusanovFluxSaturationEquationIncomp_PWC(
        double safetyFactor,
        int nSpace,
        int pskModelFlag,
        int nParams,
        np.ndarray rowptr,
        np.ndarray colind,
        np.ndarray materialTypes,
        double muw,
        double mun,
        np.ndarray omega,
        np.ndarray Kbar,
        double b,
        np.ndarray rwork_psk,
        np.ndarray rwork_psk_tol,
        np.ndarray rwork_density_w,
        np.ndarray rwork_density_n,
        np.ndarray g,
        np.ndarray ebq_global_qt,
        np.ndarray q_lambda_bar,
        int nElements_global,
        int nElementBoundaries_element,
        int nInteriorElementBoundaries_global,
        int nExteriorElementBoundaries_global,
        int nQuadraturePoints_element, 
        int nQuadraturePoints_elementBoundary,
        np.ndarray interiorElementBoundaries,
        np.ndarray exteriorElementBoundaries,
        np.ndarray elementBoundaryElements,
        np.ndarray elementBoundaryLocalElementBoundaries,
        np.ndarray n,
        np.ndarray q_u,
        np.ndarray q_dV,
        np.ndarray isDOFBoundary,
        np.ndarray bc_u,
        np.ndarray flux):
    cdef int failed = cppsstc.calculateRusanovFluxSaturationEquationIncomp_PWC(
        safetyFactor,
        nSpace,
        pskModelFlag,
        nParams,
        <int*>(rowptr.data),
        <int*>(colind.data),
        <int*>(materialTypes.data),
        muw,
        mun,
        <double*>(omega.data),
        <double*>(Kbar.data),
        b,
        <double*>(rwork_psk.data),
        <double*>(rwork_psk_tol.data),
        <double*>(rwork_density_w.data),
        <double*>(rwork_density_n.data),
        <double*>(g.data),
        <double*>(ebq_global_qt.data),
        <double*>(q_lambda_bar.data),
        nElements_global,
        nElementBoundaries_element,
        nInteriorElementBoundaries_global,
        nExteriorElementBoundaries_global,
        nQuadraturePoints_element, 
        nQuadraturePoints_elementBoundary,
        <int*>(interiorElementBoundaries.data),
        <int*>(exteriorElementBoundaries.data),
        <int*>(elementBoundaryElements.data),
        <int*>( elementBoundaryLocalElementBoundaries.data),
        <double*>(n.data),
        <double*>(q_u.data),
        <double*>(q_dV.data),
        <int*>(isDOFBoundary.data),
        <double*>(bc_u.data),
        <double*>(flux.data))
    assert failed==0

def piecewiseLinearTableLookup(double x,
                               np.ndarray xv,
                               np.ndarray yv,
                               int start=0):
    cdef double y=0
    cdef double dy=0
    cppsstc.piecewiseLinearTableLookup(x,
                                       xv.shape[0],
                                       &start,
                                       &y,
                                       &dy,
                                       <double*>(xv.data),
                                       <double*>(yv.data))
    return (y, dy, start)
