# A type of -*- python -*- file
# cython: language_level=3
import numpy as np
cimport numpy as np
cdef extern from "subgridError.h":
    void ccalculateSubgridError_tauRes "calculateSubgridError_tauRes"(int nElements_global,
                                    int nQuadraturePoints_element,
                                    int nDOF_trial_element,
                                    double* tau,
                                    double* pdeResidual,
                                    double* dpdeResidual,
                                    double* subgridError,
                                    double* dsubgridError)
    void ccalculateSubgridError_ADR_generic_tau "calculateSubgridError_ADR_generic_tau"(int nElements_global,
                                            int nQuadraturePoints_element,
                                            int nSpace,
                                            double* inverseJ,
                                            double* dmt,
                                            double* df,
                                            double* a,
                                            double* da,
                                            double* grad_phi,
                                            double* dphi,
                                            double* dr,
                                            double* pe,
                                            double* cfl,
                                            double* tau)
    void ccalculateSubgridError_ADR_generic_tau_sd "calculateSubgridError_ADR_generic_tau_sd"(int nElements_global,
                            int nQuadraturePoints_element,
                            int nSpace,
                            int* rowptr,
                            int* colind,
                            double* inverseJ,
                            double* dmt,
                            double* df,
                            double* a,
                            double* da,
                            double* grad_phi,
                            double* dphi,
                            double* dr,
                            double* pe,
                            double* cfl,
                            double* tau)
    void ccalculateSubgridError_ADR_tau "calculateSubgridError_ADR_tau"(int nElements_global,
                                    int nQuadraturePoints_element,
                                    int nSpace,
                                    char stabilization,
                                    double* elementDiameter,
                                    double* dmt,
                                    double* df,
                                    double* a,
                                    double* da,
                                    double* grad_phi,
                                    double* dphi,
                                    double* dr,
                                    double* pe,
                                    double* cfl,
                                    double* tau)
    void ccalculateSubgridError_ADR_tau_sd "calculateSubgridError_ADR_tau_sd"(int nElements_global,
                        int nQuadraturePoints_element,
                        int nSpace,
                        int* rowptr,
                        int* colind,
                        char stabilization,
                        double* elementDiameter,
                        double* dmt,
                        double* df,
                        double* a,
                        double* da,
                        double* grad_phi,
                        double* dphi,
                        double* dr,
                        double* pe,
                        double* cfl,
                        double* tau)
    void ccalculateSubgridError_A_tau "calculateSubgridError_A_tau"(int nElements_global,
                                    int nQuadraturePoints_element,
                                    int nSpace,
                                    char stabilization,
                                    double* elementDiameter,
                                    double* dmt,
                                    double* df,
                                    double* cfl,
                                    double* tau)
    void ccalculateSubgridErrorStokes2D_GLS_velocity "calculateSubgridErrorStokes2D_GLS_velocity"(int nElements_global,
                                                    int nQuadraturePoints_element,
                                                    int nDOF_trial_element,
                                                    int nSpace,
                                                    double* elementDiameter,
                                                    double* a,
                                                    double* pdeResidualU,
                                                    double* dpdeResidualU_dp,
                                                    double* dpdeResidualU_du,
                                                    double* pdeResidualV,
                                                    double* dpdeResidualV_dp,
                                                    double* dpdeResidualV_dv,
                                                    double* subgridErrorU,
                                                    double* dsubgridErrorU_dp,
                                                    double* dsubgridErrorU_du,
                                                    double* subgridErrorV,
                                                    double* dsubgridErrorV_dp,
                                                    double* dsubgridErrorV_dv)
    void ccalculateSubgridErrorStokes2D_GLS_velocity_sd "calculateSubgridErrorStokes2D_GLS_velocity_sd"(int nElements_global,
                            int nQuadraturePoints_element,
                            int nDOF_trial_element,
                            int nSpace,
                            double* elementDiameter,
                            double* a,
                            double* pdeResidualU,
                            double* dpdeResidualU_dp,
                            double* dpdeResidualU_du,
                            double* pdeResidualV,
                            double* dpdeResidualV_dp,
                            double* dpdeResidualV_dv,
                            double* subgridErrorU,
                            double* dsubgridErrorU_dp,
                            double* dsubgridErrorU_du,
                            double* subgridErrorV,
                            double* dsubgridErrorV_dp,
                            double* dsubgridErrorV_dv)
    void ccalculateSubgridErrorStokes3D_GLS_velocity "calculateSubgridErrorStokes3D_GLS_velocity"(int nElements_global,
                                                    int nQuadraturePoints_element,
                                                    int nDOF_trial_element,
                                                    int nSpace,
                                                    double* elementDiameter,
                                                    double* a,
                                                    double* pdeResidualU,
                                                    double* dpdeResidualU_dp,
                                                    double* dpdeResidualU_du,
                                                    double* pdeResidualV,
                                                    double* dpdeResidualV_dp,
                                                    double* dpdeResidualV_dv,
                                                    double* pdeResidualW,
                                                    double* dpdeResidualW_dp,
                                                    double* dpdeResidualW_dw,
                                                    double* subgridErrorU,
                                                    double* dsubgridErrorU_dp,
                                                    double* dsubgridErrorU_du,
                                                    double* subgridErrorV,
                                                    double* dsubgridErrorV_dp,
                                                    double* dsubgridErrorV_dv,
                                                    double* subgridErrorW,
                                                    double* dsubgridErrorW_dp,
                                                    double* dsubgridErrorW_dw)
    void ccalculateSubgridErrorStokes3D_GLS_velocity_sd "calculateSubgridErrorStokes3D_GLS_velocity_sd"(int nElements_global,
                            int nQuadraturePoints_element,
                            int nDOF_trial_element,
                            int nSpace,
                            double* elementDiameter,
                            double* a,
                            double* pdeResidualU,
                            double* dpdeResidualU_dp,
                            double* dpdeResidualU_du,
                            double* pdeResidualV,
                            double* dpdeResidualV_dp,
                            double* dpdeResidualV_dv,
                            double* pdeResidualW,
                            double* dpdeResidualW_dp,
                            double* dpdeResidualW_dw,
                            double* subgridErrorU,
                            double* dsubgridErrorU_dp,
                            double* dsubgridErrorU_du,
                            double* subgridErrorV,
                            double* dsubgridErrorV_dp,
                            double* dsubgridErrorV_dv,
                            double* subgridErrorW,
                            double* dsubgridErrorW_dp,
                            double* dsubgridErrorW_dw)
    void ccalculateSubgridErrorStokes2D_GLS_velocity_pressure "calculateSubgridErrorStokes2D_GLS_velocity_pressure"(int nElements_global,
                                                            int nQuadraturePoints_element,
                                                            int nDOF_trial_element,
                                                            int nSpace,
                                                            double* elementDiameter,
                                                            double* a,
                                                            double* pdeResidualP,
                                                            double* dpdeResidualP_du,
                                                            double* dpdeResidualP_dv,
                                                            double* pdeResidualU,
                                                            double* dpdeResidualU_dp,
                                                            double* dpdeResidualU_du,
                                                            double* pdeResidualV,
                                                            double* dpdeResidualV_dp,
                                                            double* dpdeResidualV_dv,
                                                            double* subgridErrorP,
                                                            double* dsubgridErrorP_du,
                                                            double* dsubgridErrorP_dv,
                                                            double* subgridErrorU,
                                                            double* dsubgridErrorU_dp,
                                                            double* dsubgridErrorU_du,
                                                            double* subgridErrorV,
                                                            double* dsubgridErrorV_dp,
                                                            double* dsubgridErrorV_dv)
    void ccalculateSubgridErrorStokes2D_GLS_velocity_pressure_sd "calculateSubgridErrorStokes2D_GLS_velocity_pressure_sd"(int nElements_global,
                                                            int nQuadraturePoints_element,
                                                            int nDOF_trial_element,
                                                            int nSpace,
                                                            double* elementDiameter,
                                                            double* a,
                                                            double* pdeResidualP,
                                                            double* dpdeResidualP_du,
                                                            double* dpdeResidualP_dv,
                                                            double* pdeResidualU,
                                                            double* dpdeResidualU_dp,
                                                            double* dpdeResidualU_du,
                                                            double* pdeResidualV,
                                                            double* dpdeResidualV_dp,
                                                            double* dpdeResidualV_dv,
                                                            double* subgridErrorP,
                                                            double* dsubgridErrorP_du,
                                                            double* dsubgridErrorP_dv,
                                                            double* subgridErrorU,
                                                            double* dsubgridErrorU_dp,
                                                            double* dsubgridErrorU_du,
                                                            double* subgridErrorV,
                                                            double* dsubgridErrorV_dp,
                                                            double* dsubgridErrorV_dv)
    void ccalculateSubgridErrorStokes3D_GLS_velocity_pressure "calculateSubgridErrorStokes3D_GLS_velocity_pressure"(int nElements_global,
                                                            int nQuadraturePoints_element,
                                                            int nDOF_trial_element,
                                                            int nSpace,
                                                            double* elementDiameter,
                                                            double* a,
                                                            double* pdeResidualP,
                                                            double* dpdeResidualP_du,
                                                            double* dpdeResidualP_dv,
                                                            double* dpdeResidualP_dw,
                                                            double* pdeResidualU,
                                                            double* dpdeResidualU_dp,
                                                            double* dpdeResidualU_du,
                                                            double* pdeResidualV,
                                                            double* dpdeResidualV_dp,
                                                            double* dpdeResidualV_dv,
                                                            double* pdeResidualW,
                                                            double* dpdeResidualW_dp,
                                                            double* dpdeResidualW_dw,
                                                            double* subgridErrorP,
                                                            double* dsubgridErrorP_du,
                                                            double* dsubgridErrorP_dv,
                                                            double* dsubgridErrorP_dw,
                                                            double* subgridErrorU,
                                                            double* dsubgridErrorU_dp,
                                                            double* dsubgridErrorU_du,
                                                            double* subgridErrorV,
                                                            double* dsubgridErrorV_dp,
                                                            double* dsubgridErrorV_dv,
                                                            double* subgridErrorW,
                                                            double* dsubgridErrorW_dp,
                                                            double* dsubgridErrorW_dw)
    void ccalculateSubgridErrorStokes3D_GLS_velocity_pressure_sd "calculateSubgridErrorStokes3D_GLS_velocity_pressure_sd"(int nElements_global,
                                                            int nQuadraturePoints_element,
                                                            int nDOF_trial_element,
                                                            int nSpace,
                                                            double* elementDiameter,
                                                            double* a,
                                                            double* pdeResidualP,
                                                            double* dpdeResidualP_du,
                                                            double* dpdeResidualP_dv,
                                                            double* dpdeResidualP_dw,
                                                            double* pdeResidualU,
                                                            double* dpdeResidualU_dp,
                                                            double* dpdeResidualU_du,
                                                            double* pdeResidualV,
                                                            double* dpdeResidualV_dp,
                                                            double* dpdeResidualV_dv,
                                                            double* pdeResidualW,
                                                            double* dpdeResidualW_dp,
                                                            double* dpdeResidualW_dw,
                                                            double* subgridErrorP,
                                                            double* dsubgridErrorP_du,
                                                            double* dsubgridErrorP_dv,
                                                            double* dsubgridErrorP_dw,
                                                            double* subgridErrorU,
                                                            double* dsubgridErrorU_dp,
                                                            double* dsubgridErrorU_du,
                                                            double* subgridErrorV,
                                                            double* dsubgridErrorV_dp,
                                                            double* dsubgridErrorV_dv,
                                                            double* subgridErrorW,
                                                            double* dsubgridErrorW_dp,
                                                            double* dsubgridErrorW_dw)
    void ccalculateSubgridErrorNavierStokes2D_GLS_tau "calculateSubgridErrorNavierStokes2D_GLS_tau"(int nElements_global,
                                                    int nQuadraturePoints_element,
                                                    int nSpace,
                                                    double  hFactor,
                                                    double* elementDiameter,
                                                    double* dmt,
                                                    double* dm,
                                                    double* f,
                                                    double* a,
                                                    double* tau0,
                                                    double* tau1,
                                                    double* cfl)
    void ccalculateSubgridErrorNavierStokes2D_GLS_tau_sd "calculateSubgridErrorNavierStokes2D_GLS_tau_sd"(int nElements_global,
                                                    int nQuadraturePoints_element,
                                                    int nSpace,
                                                    double  hFactor,
                                                    double* elementDiameter,
                                                    double* dmt,
                                                    double* dm,
                                                    double* f,
                                                    double* a,
                                                    double* tau0,
                                                    double* tau1,
                                                    double* cfl)
    void ccalculateSubgridErrorNavierStokes2D_generic_tau "calculateSubgridErrorNavierStokes2D_generic_tau"(int nElements_global,
                                                        int nQuadraturePoints_element,
                                                        int nSpace,
                                                        double* inverseJ,
                                                        double* dmt,
                                                        double* dm,
                                                        double* f,
                                                        double* a,
                                                        double* tau0,
                                                        double* tau1,
                                                        double* cfl)
    void ccalculateSubgridErrorNavierStokes2D_generic_tau_sd "calculateSubgridErrorNavierStokes2D_generic_tau_sd"(int nElements_global,
                                                        int nQuadraturePoints_element,
                                                        int nSpace,
                                                        double* inverseJ,
                                                        double* dmt,
                                                        double* dm,
                                                        double* f,
                                                        double* a,
                                                        double* tau0,
                                                        double* tau1,
                                                        double* cfl)
    void ccalculateSubgridErrorNavierStokes2D_generic_withBodyForce_tau "calculateSubgridErrorNavierStokes2D_generic_withBodyForce_tau"(int nElements_global,
                                    int nQuadraturePoints_element,
                                    int nSpace,
                                    double* inverseJ,
                                    double* dmt,
                                    double* dm,
                                    double* f,
                                    double* a,
                                    double* dr,
                                    double* tau0,
                                    double* tau1,
                                    double* cfl)
    void ccalculateSubgridErrorNavierStokes2D_generic_withBodyForce_tau_sd "calculateSubgridErrorNavierStokes2D_generic_withBodyForce_tau_sd"(int nElements_global,
                                    int nQuadraturePoints_element,
                                    int nSpace,
                                    double* inverseJ,
                                    double* dmt,
                                    double* dm,
                                    double* f,
                                    double* a,
                                    double* dr,
                                    double* tau0,
                                    double* tau1,
                                    double* cfl)
    void ccalculateSubgridErrorNavierStokes2D_GLS_tauRes "calculateSubgridErrorNavierStokes2D_GLS_tauRes"(int nElements_global,
                                                        int nQuadraturePoints_element,
                                                        int nDOF_trial_element,
                                                        int nSpace,
                                                        double* tau0,
                                                        double* tau1,
                                                        double* pdeResidualP,
                                                        double* dpdeResidualP_du,
                                                        double* dpdeResidualP_dv,
                                                        double* pdeResidualU,
                                                        double* dpdeResidualU_dp,
                                                        double* dpdeResidualU_du,
                                                        double* dpdeResidualU_dv,
                                                        double* pdeResidualV,
                                                        double* dpdeResidualV_dp,
                                                        double* dpdeResidualV_du,
                                                        double* dpdeResidualV_dv,
                                                        double* subgridErrorP,
                                                        double* dsubgridErrorP_du,
                                                        double* dsubgridErrorP_dv,
                                                        double* subgridErrorU,
                                                        double* dsubgridErrorU_dp,
                                                        double* dsubgridErrorU_du,
                                                        double* dsubgridErrorU_dv,
                                                        double* subgridErrorV,
                                                        double* dsubgridErrorV_dp,
                                                        double* dsubgridErrorV_du,
                                                        double* dsubgridErrorV_dv)
    void ccalculateSubgridErrorStokes_GLS_tau "calculateSubgridErrorStokes_GLS_tau"(int nElements_global,
                                            int nQuadraturePoints_element,
                                            int nSpace,
                                            double* elementDiameter,
                                            double* pfac,
                                            double* a,
                                            double* tau0,
                                            double* tau1)
    void ccalculateSubgridErrorStokes_GLS_tau_sd "calculateSubgridErrorStokes_GLS_tau_sd"(int nElements_global,
                                                int nQuadraturePoints_element,
                                                int nSpace,
                                                double* elementDiameter,
                                                double* pfac,
                                                double* a,
                                                double* tau0,
                                                double* tau1)
    void ccalculateSubgridErrorStokes2D_GLS_tauRes "calculateSubgridErrorStokes2D_GLS_tauRes"(int nElements_global,
                                                int nQuadraturePoints_element,
                                                int nDOF_trial_element,
                                                int nSpace,
                                                double* tau0,
                                                double* tau1,
                                                double* pdeResidualP,
                                                double* dpdeResidualP_du,
                                                double* dpdeResidualP_dv,
                                                double* pdeResidualU,
                                                double* dpdeResidualU_dp,
                                                double* dpdeResidualU_du,
                                                double* pdeResidualV,
                                                double* dpdeResidualV_dp,
                                                double* dpdeResidualV_dv,
                                                double* subgridErrorP,
                                                double* dsubgridErrorP_du,
                                                double* dsubgridErrorP_dv,
                                                double* subgridErrorU,
                                                double* dsubgridErrorU_dp,
                                                double* dsubgridErrorU_du,
                                                double* subgridErrorV,
                                                double* dsubgridErrorV_dp,
                                                double* dsubgridErrorV_dv)
    void ccalculateSubgridErrorStokes3D_GLS_tauRes "calculateSubgridErrorStokes3D_GLS_tauRes"(int nElements_global,
                            int nQuadraturePoints_element,
                            int nDOF_trial_element,
                            int nSpace,
                            double* tau0,
                            double* tau1,
                            double* pdeResidualP,
                            double* dpdeResidualP_du,
                            double* dpdeResidualP_dv,
                            double* dpdeResidualP_dw,
                            double* pdeResidualU,
                            double* dpdeResidualU_dp,
                            double* dpdeResidualU_du,
                            double* pdeResidualV,
                            double* dpdeResidualV_dp,
                            double* dpdeResidualV_dv,
                            double* pdeResidualW,
                            double* dpdeResidualW_dp,
                            double* dpdeResidualW_dw,
                            double* subgridErrorP,
                            double* dsubgridErrorP_du,
                            double* dsubgridErrorP_dv,
                            double* dsubgridErrorP_dw,
                            double* subgridErrorU,
                            double* dsubgridErrorU_dp,
                            double* dsubgridErrorU_du,
                            double* subgridErrorV,
                            double* dsubgridErrorV_dp,
                            double* dsubgridErrorV_dv,
                            double* subgridErrorW,
                            double* dsubgridErrorW_dp,
                            double* dsubgridErrorW_dw)
    void ccalculateSubgridErrorNavierStokes3D_GLS_tauRes "calculateSubgridErrorNavierStokes3D_GLS_tauRes"(int nElements_global,
                                                        int nQuadraturePoints_element,
                                                        int nDOF_trial_element,
                                                        int nSpace,
                                                        double* tau0,
                                                        double* tau1,
                                                        double* pdeResidualP,
                                                        double* dpdeResidualP_du,
                                                        double* dpdeResidualP_dv,
                                                        double* dpdeResidualP_dw,
                                                        double* pdeResidualU,
                                                        double* dpdeResidualU_dp,
                                                        double* dpdeResidualU_du,
                                                        double* dpdeResidualU_dv,
                                                        double* dpdeResidualU_dw,
                                                        double* pdeResidualV,
                                                        double* dpdeResidualV_dp,
                                                        double* dpdeResidualV_du,
                                                        double* dpdeResidualV_dv,
                                                        double* dpdeResidualV_dw,
                                                        double* pdeResidualW,
                                                        double* dpdeResidualW_dp,
                                                        double* dpdeResidualW_du,
                                                        double* dpdeResidualW_dv,
                                                        double* dpdeResidualW_dw,
                                                        double* subgridErrorP,
                                                        double* dsubgridErrorP_du,
                                                        double* dsubgridErrorP_dv,
                                                        double* dsubgridErrorP_dw,
                                                        double* subgridErrorU,
                                                        double* dsubgridErrorU_dp,
                                                        double* dsubgridErrorU_du,
                                                        double* dsubgridErrorU_dv,
                                                        double* dsubgridErrorU_dw,
                                                        double* subgridErrorV,
                                                        double* dsubgridErrorV_dp,
                                                        double* dsubgridErrorV_du,
                                                        double* dsubgridErrorV_dv,
                                                        double* dsubgridErrorV_dw,
                                                        double* subgridErrorW,
                                                        double* dsubgridErrorW_dp,
                                                        double* dsubgridErrorW_du,
                                                        double* dsubgridErrorW_dv,
                                                        double* dsubgridErrorW_dw)
    void ccalculateSubgridErrorNavierStokes3D_GLS_velocity_pressure "calculateSubgridErrorNavierStokes3D_GLS_velocity_pressure"(int nElements_global,
                                                                int nQuadraturePoints_element,
                                                                int nDOF_trial_element,
                                                                int nSpace,
                                                                double* elementDiameter,
                                                                double* dm,
                                                                double* f,
                                                                double* a,
                                                                double* pdeResidualP,
                                                                double* dpdeResidualP_du,
                                                                double* dpdeResidualP_dv,
                                                                double* dpdeResidualP_dw,
                                                                double* pdeResidualU,
                                                                double* dpdeResidualU_dp,
                                                                double* dpdeResidualU_du,
                                                                double* pdeResidualV,
                                                                double* dpdeResidualV_dp,
                                                                double* dpdeResidualV_dv,
                                                                double* pdeResidualW,
                                                                double* dpdeResidualW_dp,
                                                                double* dpdeResidualW_dw,
                                                                double* subgridErrorP,
                                                                double* dsubgridErrorP_du,
                                                                double* dsubgridErrorP_dv,
                                                                double* dsubgridErrorP_dw,
                                                                double* subgridErrorU,
                                                                double* dsubgridErrorU_dp,
                                                                double* dsubgridErrorU_du,
                                                                double* subgridErrorV,
                                                                double* dsubgridErrorV_dp,
                                                                double* dsubgridErrorV_dv,
                                                                double* subgridErrorW,
                                                                double* dsubgridErrorW_dp,
                                                                double* dsubgridErrorW_dw)
    void ccalculateSubgridErrorNavierStokes3D_GLS_velocity_pressure_sd "calculateSubgridErrorNavierStokes3D_GLS_velocity_pressure_sd"(int nElements_global,
                                                                int nQuadraturePoints_element,
                                                                int nDOF_trial_element,
                                                                int nSpace,
                                                                double* elementDiameter,
                                                                double* dm,
                                                                double* f,
                                                                double* a,
                                                                double* pdeResidualP,
                                                                double* dpdeResidualP_du,
                                                                double* dpdeResidualP_dv,
                                                                double* dpdeResidualP_dw,
                                                                double* pdeResidualU,
                                                                double* dpdeResidualU_dp,
                                                                double* dpdeResidualU_du,
                                                                double* pdeResidualV,
                                                                double* dpdeResidualV_dp,
                                                                double* dpdeResidualV_dv,
                                                                double* pdeResidualW,
                                                                double* dpdeResidualW_dp,
                                                                double* dpdeResidualW_dw,
                                                                double* subgridErrorP,
                                                                double* dsubgridErrorP_du,
                                                                double* dsubgridErrorP_dv,
                                                                double* dsubgridErrorP_dw,
                                                                double* subgridErrorU,
                                                                double* dsubgridErrorU_dp,
                                                                double* dsubgridErrorU_du,
                                                                double* subgridErrorV,
                                                                double* dsubgridErrorV_dp,
                                                                double* dsubgridErrorV_dv,
                                                                double* subgridErrorW,
                                                                double* dsubgridErrorW_dp,
                                                                double* dsubgridErrorW_dw)
    void ccalculateSubgridErrorStokes2D_1 "calculateSubgridErrorStokes2D_1"(int nElements_global,
                                        int nQuadraturePoints_element,
                                        int nDOF_trial_element,
                                        int nSpace,
                                        double* elementDiameter,
                                        double* u,
                                        double* v,
                                        double* a,
                                        double* pdeResidualP,
                                        double* dpdeResidualP_du,
                                        double* dpdeResidualP_dv,
                                        double* pdeResidualU,
                                        double* dpdeResidualU_dp,
                                        double* dpdeResidualU_du,
                                        double* pdeResidualV,
                                        double* dpdeResidualV_dp,
                                        double* dpdeResidualV_dv,
                                        double* subgridErrorP,
                                        double* dsubgridErrorP_dp,
                                        double* dsubgridErrorP_du,
                                        double* dsubgridErrorP_dv,
                                        double* subgridErrorU,
                                        double* dsubgridErrorU_dp,
                                        double* dsubgridErrorU_du,
                                        double* dsubgridErrorU_dv,
                                        double* subgridErrorV,
                                        double* dsubgridErrorV_dp,
                                        double* dsubgridErrorV_du,
                                        double* dsubgridErrorV_dv)
    void ccalculateSubgridErrorStokes2D_1_sd "calculateSubgridErrorStokes2D_1_sd"(int nElements_global,
                                        int nQuadraturePoints_element,
                                        int nDOF_trial_element,
                                        int nSpace,
                                        double* elementDiameter,
                                        double* u,
                                        double* v,
                                        double* a,
                                        double* pdeResidualP,
                                        double* dpdeResidualP_du,
                                        double* dpdeResidualP_dv,
                                        double* pdeResidualU,
                                        double* dpdeResidualU_dp,
                                        double* dpdeResidualU_du,
                                        double* pdeResidualV,
                                        double* dpdeResidualV_dp,
                                        double* dpdeResidualV_dv,
                                        double* subgridErrorP,
                                        double* dsubgridErrorP_dp,
                                        double* dsubgridErrorP_du,
                                        double* dsubgridErrorP_dv,
                                        double* subgridErrorU,
                                        double* dsubgridErrorU_dp,
                                        double* dsubgridErrorU_du,
                                        double* dsubgridErrorU_dv,
                                        double* subgridErrorV,
                                        double* dsubgridErrorV_dp,
                                        double* dsubgridErrorV_du,
                                        double* dsubgridErrorV_dv)
    void ccalculateSubgridErrorShallowWater1D "calculateSubgridErrorShallowWater1D"(int nElements_global,
                                            int nQuadraturePoints_element,
                                            double g,
                                            double* elementDiameter,
                                            double* h,
                                            double* hu,
                                            double* cfl_1,
                                            double* cfl_2)
    void ccalculateSubgridErrorShallowWater2D "calculateSubgridErrorShallowWater2D"(int nElements_global,
                                            int nQuadraturePoints_element,
                                            double g,
                                            double* elementDiameter,
                                            double* h,
                                            double* hu,
                                            double* hv,
                                            double* cfl_1,
                                            double* cfl_2,
                                            double* cfl_3)
    void ccalculateSubgridError_Harari_tau_sd "calculateSubgridError_Harari_tau_sd"(int nElements_global,
                        int nQuadraturePoints_element,
                        int nSpace,
                        double dt,
                        int* rowptr,
                        int* colind,
                        double* elementDiameter,
                        double* a,
                        double* tau)
    void ccalculateSubgridErrorGradient_tauRes "calculateSubgridErrorGradient_tauRes"(int nElements_global,
                        int nQuadraturePoints_element,
                        int nSpace,
                        double* tau_gradient,
                        double* grad_pdeResidual,
                        double* grad_subgridError)
    void ccalculateSubgridError_ADR_Sangalli_tau_sd "calculateSubgridError_ADR_Sangalli_tau_sd"(int nElements_global,
                            int nQuadraturePoints_element,
                            int nSpace,
                            int* rowptr,
                            int* colind,
                            double* inverseJ,
                            double* dmt,
                            double* df,
                            double* a,
                            double* da,
                            double* grad_phi,
                            double* dphi,
                            double* dr,
                            double* pe,
                            double* cfl,
                            double* tau,
                            double* tau_gradient)
def calculateSubgridError_tauRes(np.ndarray tau,
                                  np.ndarray pdeResidual,
                                  np.ndarray dpdeResidual,
                                  np.ndarray subgridError,
                                  np.ndarray dsubgridError):
    ccalculateSubgridError_tauRes(dsubgridError.shape[0],
                                dsubgridError.shape[1],
                                dsubgridError.shape[2],
                                <double*> tau.data,
                                <double*> pdeResidual.data,
                                <double*> dpdeResidual.data,
                                <double*> subgridError.data,
                                <double*> dsubgridError.data)
def calculateSubgridError_ADR_generic_tau(np.ndarray inverseJ,
                                           np.ndarray dmt,
                                           np.ndarray df,
                                           np.ndarray a,
                                           np.ndarray da,
                                           np.ndarray grad_phi,
                                           np.ndarray dphi,
                                           np.ndarray dr,
                                           np.ndarray pe,
                                           np.ndarray cfl,
                                           np.ndarray tau):
    ccalculateSubgridError_ADR_generic_tau(df.shape[0],
                                        df.shape[1],
                                        df.shape[2],
                                        <double*> inverseJ.data,
                                        <double*> dmt.data,
                                        <double*> df.data,
                                        <double*> a.data,
                                        <double*> da.data,
                                        <double*> grad_phi.data,
                                        <double*> dphi.data,
                                        <double*> dr.data,
                                        <double*> pe.data,
                                        <double*> cfl.data,
                                        <double*> tau.data)
def calculateSubgridError_ADR_generic_tau_sd(np.ndarray rowptr,
                                        np.ndarray colind,
                                        np.ndarray inverseJ,
                                        np.ndarray dmt,
                                        np.ndarray df,
                                        np.ndarray a,
                                        np.ndarray da,
                                        np.ndarray grad_phi,
                                        np.ndarray dphi,
                                        np.ndarray dr,
                                        np.ndarray pe,
                                        np.ndarray cfl,
                                        np.ndarray tau):
    ccalculateSubgridError_ADR_generic_tau_sd(df.shape[0],
                                        df.shape[1],
                                        df.shape[2],
                                        <int*> rowptr.data,
                                        <int*> colind.data,
                                        <double*> inverseJ.data,
                                        <double*> dmt.data,
                                        <double*> df.data,
                                        <double*> a.data,
                                        <double*> da.data,
                                        <double*> grad_phi.data,
                                        <double*> dphi.data,
                                        <double*> dr.data,
                                        <double*> pe.data,
                                        <double*> cfl.data,
                                        <double*> tau.data)
def calculateSubgridError_ADR_tau(char stabilization,
                                   np.ndarray elementDiameter,
                                   np.ndarray dmt,
                                   np.ndarray df,
                                   np.ndarray a,
                                   np.ndarray da,
                                   np.ndarray grad_phi,
                                   np.ndarray dphi,
                                   np.ndarray dr,
                                   np.ndarray pe,
                                   np.ndarray cfl,
                                   np.ndarray tau):
    ccalculateSubgridError_ADR_tau(df.shape[0],
                                    df.shape[1],
                                    df.shape[2],
                                   stabilization,
                                   <double*> elementDiameter.data,
                                   <double*> dmt.data,
                                   <double*> df.data,
                                   <double*> a.data,
                                   <double*> da.data,
                                   <double*> grad_phi.data,
                                   <double*> dphi.data,
                                   <double*> dr.data,
                                   <double*> pe.data,
                                   <double*> cfl.data,
                                   <double*> tau.data)
def calculateSubgridError_ADR_tau_sd(char stabilization,
                                    np.ndarray rowptr,
                                    np.ndarray colind,
                                    np.ndarray elementDiameter,
                                    np.ndarray dmt,
                                    np.ndarray df,
                                    np.ndarray a,
                                    np.ndarray da,
                                    np.ndarray grad_phi,
                                    np.ndarray dphi,
                                    np.ndarray dr,
                                    np.ndarray pe,
                                    np.ndarray cfl,
                                    np.ndarray tau):
    ccalculateSubgridError_ADR_tau_sd(df.shape[0],
                                    df.shape[1],
                                    df.shape[2],
                                    <int*> rowptr.data,
                                    <int*> colind.data,
                                    stabilization,
                                    <double*> elementDiameter.data,
                                    <double*> dmt.data,
                                    <double*> df.data,
                                    <double*> a.data,
                                    <double*> da.data,
                                    <double*> grad_phi.data,
                                    <double*> dphi.data,
                                    <double*> dr.data,
                                    <double*> pe.data,
                                    <double*> cfl.data,
                                    <double*> tau.data)
def calculateSubgridError_A_tau(char stabilization,
                                  np.ndarray elementDiameter,
                                  np.ndarray dmt,
                                  np.ndarray df,
                                  np.ndarray cfl,
                                  np.ndarray tau):
    ccalculateSubgridError_A_tau(df.shape[0],
                                df.shape[1],
                                df.shape[2],
                                stabilization,
                                <double*> elementDiameter.data,
                                <double*> dmt.data,
                                <double*> df.data,
                                <double*> cfl.data,
                                <double*> tau.data)
def calculateSubgridError_HJ_tau(char stabilization,
                                  np.ndarray elementDiameter,
                                  np.ndarray dmt,
                                  np.ndarray dH,
                                  np.ndarray cfl,
                                  np.ndarray tau):
    ccalculateSubgridError_A_tau(dH.shape[0],
                                dH.shape[1],
                                dH.shape[2],
                                stabilization,
                                <double*> elementDiameter.data,
                                <double*> dmt.data,
                                <double*> dH.data,
                                <double*> cfl.data,
                                <double*> tau.data)

def calculateSubgridErrorStokes2D_GLS_velocity(np.ndarray elementDiameter,
                                                np.ndarray a,
                                                np.ndarray pdeResidualU,
                                                np.ndarray dpdeResidualU_dp,
                                                np.ndarray dpdeResidualU_du,
                                                np.ndarray pdeResidualV,
                                                np.ndarray dpdeResidualV_dp,
                                                np.ndarray dpdeResidualV_dv,
                                                np.ndarray subgridErrorU,
                                                np.ndarray dsubgridErrorU_dp,
                                                np.ndarray dsubgridErrorU_du,
                                                np.ndarray subgridErrorV,
                                                np.ndarray dsubgridErrorV_dp,
                                                np.ndarray dsubgridErrorV_dv):
    ccalculateSubgridErrorStokes2D_GLS_velocity(dsubgridErrorU_du.shape[0],
                                                dsubgridErrorU_du.shape[1],
                                                dsubgridErrorU_du.shape[2],
                                                2,
                                                <double*> elementDiameter.data,
                                                <double*> a.data,
                                                <double*> pdeResidualU.data,
                                                <double*> dpdeResidualU_dp.data,
                                                <double*> dpdeResidualU_du.data,
                                                <double*> pdeResidualV.data,
                                                <double*> dpdeResidualV_dp.data,
                                                <double*> dpdeResidualV_dv.data,
                                                <double*> subgridErrorU.data,
                                                <double*> dsubgridErrorU_dp.data,
                                                <double*> dsubgridErrorU_du.data,
                                                <double*> subgridErrorV.data,
                                                <double*> dsubgridErrorV_dp.data,
                                                <double*> dsubgridErrorV_dv.data)
def calculateSubgridErrorStokes2D_GLS_velocity_sd(np.ndarray elementDiameter,
                                                np.ndarray a,
                                                np.ndarray pdeResidualU,
                                                np.ndarray dpdeResidualU_dp,
                                                np.ndarray dpdeResidualU_du,
                                                np.ndarray pdeResidualV,
                                                np.ndarray dpdeResidualV_dp,
                                                np.ndarray dpdeResidualV_dv,
                                                np.ndarray subgridErrorU,
                                                np.ndarray dsubgridErrorU_dp,
                                                np.ndarray dsubgridErrorU_du,
                                                np.ndarray subgridErrorV,
                                                np.ndarray dsubgridErrorV_dp,
                                                np.ndarray dsubgridErrorV_dv):
    ccalculateSubgridErrorStokes2D_GLS_velocity_sd(dsubgridErrorU_du.shape[0],
                                                dsubgridErrorU_du.shape[1],
                                                dsubgridErrorU_du.shape[2],
                                                2,
                                                <double*> elementDiameter.data,
                                                <double*> a.data,
                                                <double*> pdeResidualU.data,
                                                <double*> dpdeResidualU_dp.data,
                                                <double*> dpdeResidualU_du.data,
                                                <double*> pdeResidualV.data,
                                                <double*> dpdeResidualV_dp.data,
                                                <double*> dpdeResidualV_dv.data,
                                                <double*> subgridErrorU.data,
                                                <double*> dsubgridErrorU_dp.data,
                                                <double*> dsubgridErrorU_du.data,
                                                <double*> subgridErrorV.data,
                                                <double*> dsubgridErrorV_dp.data,
                                                <double*> dsubgridErrorV_dv.data)
def calculateSubgridErrorStokes3D_GLS_velocity(np.ndarray elementDiameter,
                                                np.ndarray a,
                                                np.ndarray pdeResidualU,
                                                np.ndarray dpdeResidualU_dp,
                                                np.ndarray dpdeResidualU_du,
                                                np.ndarray pdeResidualV,
                                                np.ndarray dpdeResidualV_dp,
                                                np.ndarray dpdeResidualV_dv,
                                                np.ndarray pdeResidualW,
                                                np.ndarray dpdeResidualW_dp,
                                                np.ndarray dpdeResidualW_dw,
                                                np.ndarray subgridErrorU,
                                                np.ndarray dsubgridErrorU_dp,
                                                np.ndarray dsubgridErrorU_du,
                                                np.ndarray subgridErrorV,
                                                np.ndarray dsubgridErrorV_dp,
                                                np.ndarray dsubgridErrorV_dv,
                                                np.ndarray subgridErrorW,
                                                np.ndarray dsubgridErrorW_dp,
                                                np.ndarray dsubgridErrorW_dw):
    ccalculateSubgridErrorStokes3D_GLS_velocity(dsubgridErrorU_du.shape[0],
                                                dsubgridErrorU_du.shape[1],
                                                dsubgridErrorU_du.shape[2],
                                                3,
                                                <double*> elementDiameter.data,
                                                <double*> a.data,
                                                <double*> pdeResidualU.data,
                                                <double*> dpdeResidualU_dp.data,
                                                <double*> dpdeResidualU_du.data,
                                                <double*> pdeResidualV.data,
                                                <double*> dpdeResidualV_dp.data,
                                                <double*> dpdeResidualV_dv.data,
                                                <double*> pdeResidualW.data,
                                                <double*> dpdeResidualW_dp.data,
                                                <double*> dpdeResidualW_dw.data,
                                                <double*> subgridErrorU.data,
                                                <double*> dsubgridErrorU_dp.data,
                                                <double*> dsubgridErrorU_du.data,
                                                <double*> subgridErrorV.data,
                                                <double*> dsubgridErrorV_dp.data,
                                                <double*> dsubgridErrorV_dv.data,
                                                <double*> subgridErrorW.data,
                                                <double*> dsubgridErrorW_dp.data,
                                                <double*> dsubgridErrorW_dw.data)
def calculateSubgridErrorStokes3D_GLS_velocity_sd(np.ndarray elementDiameter,
                                                np.ndarray a,
                                                np.ndarray pdeResidualU,
                                                np.ndarray dpdeResidualU_dp,
                                                np.ndarray dpdeResidualU_du,
                                                np.ndarray pdeResidualV,
                                                np.ndarray dpdeResidualV_dp,
                                                np.ndarray dpdeResidualV_dv,
                                                np.ndarray pdeResidualW,
                                                np.ndarray dpdeResidualW_dp,
                                                np.ndarray dpdeResidualW_dw,
                                                np.ndarray subgridErrorU,
                                                np.ndarray dsubgridErrorU_dp,
                                                np.ndarray dsubgridErrorU_du,
                                                np.ndarray subgridErrorV,
                                                np.ndarray dsubgridErrorV_dp,
                                                np.ndarray dsubgridErrorV_dv,
                                                np.ndarray subgridErrorW,
                                                np.ndarray dsubgridErrorW_dp,
                                                np.ndarray dsubgridErrorW_dw):
    ccalculateSubgridErrorStokes3D_GLS_velocity_sd(dsubgridErrorU_du.shape[0],
                                                dsubgridErrorU_du.shape[1],
                                                dsubgridErrorU_du.shape[2],
                                                3,
                                                <double*> elementDiameter.data,
                                                <double*> a.data,
                                                <double*> pdeResidualU.data,
                                                <double*> dpdeResidualU_dp.data,
                                                <double*> dpdeResidualU_du.data,
                                                <double*> pdeResidualV.data,
                                                <double*> dpdeResidualV_dp.data,
                                                <double*> dpdeResidualV_dv.data,
                                                <double*> pdeResidualW.data,
                                                <double*> dpdeResidualW_dp.data,
                                                <double*> dpdeResidualW_dw.data,
                                                <double*> subgridErrorU.data,
                                                <double*> dsubgridErrorU_dp.data,
                                                <double*> dsubgridErrorU_du.data,
                                                <double*> subgridErrorV.data,
                                                <double*> dsubgridErrorV_dp.data,
                                                <double*> dsubgridErrorV_dv.data,
                                                <double*> subgridErrorW.data,
                                                <double*> dsubgridErrorW_dp.data,
                                                <double*> dsubgridErrorW_dw.data)
def calculateSubgridErrorStokes2D_GLS_velocity_pressure(np.ndarray elementDiameter,
                                                         np.ndarray a,
                                                         np.ndarray pdeResidualP,
                                                         np.ndarray dpdeResidualP_du,
                                                         np.ndarray dpdeResidualP_dv,
                                                         np.ndarray pdeResidualU,
                                                         np.ndarray dpdeResidualU_dp,
                                                         np.ndarray dpdeResidualU_du,
                                                         np.ndarray pdeResidualV,
                                                         np.ndarray dpdeResidualV_dp,
                                                         np.ndarray dpdeResidualV_dv,
                                                         np.ndarray subgridErrorP,
                                                         np.ndarray dsubgridErrorP_du,
                                                         np.ndarray dsubgridErrorP_dv,
                                                         np.ndarray subgridErrorU,
                                                         np.ndarray dsubgridErrorU_dp,
                                                         np.ndarray dsubgridErrorU_du,
                                                         np.ndarray subgridErrorV,
                                                         np.ndarray dsubgridErrorV_dp,
                                                         np.ndarray dsubgridErrorV_dv):
    ccalculateSubgridErrorStokes2D_GLS_velocity_pressure(dsubgridErrorP_du.shape[0],
                                                        dsubgridErrorP_du.shape[1],
                                                        dsubgridErrorP_du.shape[2],
                                                        2,
                                                        <double*> elementDiameter.data,
                                                        <double*> a.data,
                                                        <double*> pdeResidualP.data,
                                                        <double*> dpdeResidualP_du.data,
                                                        <double*> dpdeResidualP_dv.data,
                                                        <double*> pdeResidualU.data,
                                                        <double*> dpdeResidualU_dp.data,
                                                        <double*> dpdeResidualU_du.data,
                                                        <double*> pdeResidualV.data,
                                                        <double*> dpdeResidualV_dp.data,
                                                        <double*> dpdeResidualV_dv.data,
                                                        <double*> subgridErrorP.data,
                                                        <double*> dsubgridErrorP_du.data,
                                                        <double*> dsubgridErrorP_dv.data,
                                                        <double*> subgridErrorU.data,
                                                        <double*> dsubgridErrorU_dp.data,
                                                        <double*> dsubgridErrorU_du.data,
                                                        <double*> subgridErrorV.data,
                                                        <double*> dsubgridErrorV_dp.data,
                                                        <double*> dsubgridErrorV_dv.data)
def calculateSubgridErrorStokes2D_GLS_velocity_pressure_sd(np.ndarray elementDiameter,
                                                         np.ndarray a,
                                                         np.ndarray pdeResidualP,
                                                         np.ndarray dpdeResidualP_du,
                                                         np.ndarray dpdeResidualP_dv,
                                                         np.ndarray pdeResidualU,
                                                         np.ndarray dpdeResidualU_dp,
                                                         np.ndarray dpdeResidualU_du,
                                                         np.ndarray pdeResidualV,
                                                         np.ndarray dpdeResidualV_dp,
                                                         np.ndarray dpdeResidualV_dv,
                                                         np.ndarray subgridErrorP,
                                                         np.ndarray dsubgridErrorP_du,
                                                         np.ndarray dsubgridErrorP_dv,
                                                         np.ndarray subgridErrorU,
                                                         np.ndarray dsubgridErrorU_dp,
                                                         np.ndarray dsubgridErrorU_du,
                                                         np.ndarray subgridErrorV,
                                                         np.ndarray dsubgridErrorV_dp,
                                                         np.ndarray dsubgridErrorV_dv):
    ccalculateSubgridErrorStokes2D_GLS_velocity_pressure_sd(dsubgridErrorP_du.shape[0],
                                                        dsubgridErrorP_du.shape[1],
                                                        dsubgridErrorP_du.shape[2],
                                                        2,
                                                        <double*> elementDiameter.data,
                                                        <double*> a.data,
                                                        <double*> pdeResidualP.data,
                                                        <double*> dpdeResidualP_du.data,
                                                        <double*> dpdeResidualP_dv.data,
                                                        <double*> pdeResidualU.data,
                                                        <double*> dpdeResidualU_dp.data,
                                                        <double*> dpdeResidualU_du.data,
                                                        <double*> pdeResidualV.data,
                                                        <double*> dpdeResidualV_dp.data,
                                                        <double*> dpdeResidualV_dv.data,
                                                        <double*> subgridErrorP.data,
                                                        <double*> dsubgridErrorP_du.data,
                                                        <double*> dsubgridErrorP_dv.data,
                                                        <double*> subgridErrorU.data,
                                                        <double*> dsubgridErrorU_dp.data,
                                                        <double*> dsubgridErrorU_du.data,
                                                        <double*> subgridErrorV.data,
                                                        <double*> dsubgridErrorV_dp.data,
                                                        <double*> dsubgridErrorV_dv.data)
def calculateSubgridErrorStokes3D_GLS_velocity_pressure(np.ndarray elementDiameter,
                                                         np.ndarray a,
                                                         np.ndarray pdeResidualP,
                                                         np.ndarray dpdeResidualP_du,
                                                         np.ndarray dpdeResidualP_dv,
                                                         np.ndarray dpdeResidualP_dw,
                                                         np.ndarray pdeResidualU,
                                                         np.ndarray dpdeResidualU_dp,
                                                         np.ndarray dpdeResidualU_du,
                                                         np.ndarray pdeResidualV,
                                                         np.ndarray dpdeResidualV_dp,
                                                         np.ndarray dpdeResidualV_dv,
                                                         np.ndarray pdeResidualW,
                                                         np.ndarray dpdeResidualW_dp,
                                                         np.ndarray dpdeResidualW_dw,
                                                         np.ndarray subgridErrorP,
                                                         np.ndarray dsubgridErrorP_du,
                                                         np.ndarray dsubgridErrorP_dv,
                                                         np.ndarray dsubgridErrorP_dw,
                                                         np.ndarray subgridErrorU,
                                                         np.ndarray dsubgridErrorU_dp,
                                                         np.ndarray dsubgridErrorU_du,
                                                         np.ndarray subgridErrorV,
                                                         np.ndarray dsubgridErrorV_dp,
                                                         np.ndarray dsubgridErrorV_dv,
                                                         np.ndarray subgridErrorW,
                                                         np.ndarray dsubgridErrorW_dp,
                                                         np.ndarray dsubgridErrorW_dw):
    ccalculateSubgridErrorStokes3D_GLS_velocity_pressure(dsubgridErrorP_du.shape[0],
                                                        dsubgridErrorP_du.shape[1],
                                                        dsubgridErrorP_du.shape[2],
                                                        3,
                                                        <double*> elementDiameter.data,
                                                        <double*> a.data,
                                                        <double*> pdeResidualP.data,
                                                        <double*> dpdeResidualP_du.data,
                                                        <double*> dpdeResidualP_dv.data,
                                                        <double*> dpdeResidualP_dw.data,
                                                        <double*> pdeResidualU.data,
                                                        <double*> dpdeResidualU_dp.data,
                                                        <double*> dpdeResidualU_du.data,
                                                        <double*> pdeResidualV.data,
                                                        <double*> dpdeResidualV_dp.data,
                                                        <double*> dpdeResidualV_dv.data,
                                                        <double*> pdeResidualW.data,
                                                        <double*> dpdeResidualW_dp.data,
                                                        <double*> dpdeResidualW_dw.data,
                                                        <double*> subgridErrorP.data,
                                                        <double*> dsubgridErrorP_du.data,
                                                        <double*> dsubgridErrorP_dv.data,
                                                        <double*> dsubgridErrorP_dw.data,
                                                        <double*> subgridErrorU.data,
                                                        <double*> dsubgridErrorU_dp.data,
                                                        <double*> dsubgridErrorU_du.data,
                                                        <double*> subgridErrorV.data,
                                                        <double*> dsubgridErrorV_dp.data,
                                                        <double*> dsubgridErrorV_dv.data,
                                                        <double*> subgridErrorW.data,
                                                        <double*> dsubgridErrorW_dp.data,
                                                        <double*> dsubgridErrorW_dw.data)
def calculateSubgridErrorStokes3D_GLS_velocity_pressure_sd(np.ndarray elementDiameter,
                                                         np.ndarray a,
                                                         np.ndarray pdeResidualP,
                                                         np.ndarray dpdeResidualP_du,
                                                         np.ndarray dpdeResidualP_dv,
                                                         np.ndarray dpdeResidualP_dw,
                                                         np.ndarray pdeResidualU,
                                                         np.ndarray dpdeResidualU_dp,
                                                         np.ndarray dpdeResidualU_du,
                                                         np.ndarray pdeResidualV,
                                                         np.ndarray dpdeResidualV_dp,
                                                         np.ndarray dpdeResidualV_dv,
                                                         np.ndarray pdeResidualW,
                                                         np.ndarray dpdeResidualW_dp,
                                                         np.ndarray dpdeResidualW_dw,
                                                         np.ndarray subgridErrorP,
                                                         np.ndarray dsubgridErrorP_du,
                                                         np.ndarray dsubgridErrorP_dv,
                                                         np.ndarray dsubgridErrorP_dw,
                                                         np.ndarray subgridErrorU,
                                                         np.ndarray dsubgridErrorU_dp,
                                                         np.ndarray dsubgridErrorU_du,
                                                         np.ndarray subgridErrorV,
                                                         np.ndarray dsubgridErrorV_dp,
                                                         np.ndarray dsubgridErrorV_dv,
                                                         np.ndarray subgridErrorW,
                                                         np.ndarray dsubgridErrorW_dp,
                                                         np.ndarray dsubgridErrorW_dw):
    ccalculateSubgridErrorStokes3D_GLS_velocity_pressure_sd(dsubgridErrorP_du.shape[0],
                                                        dsubgridErrorP_du.shape[1],
                                                        dsubgridErrorP_du.shape[2],
                                                        3,
                                                        <double*> elementDiameter.data,
                                                        <double*> a.data,
                                                        <double*> pdeResidualP.data,
                                                        <double*> dpdeResidualP_du.data,
                                                        <double*> dpdeResidualP_dv.data,
                                                        <double*> dpdeResidualP_dw.data,
                                                        <double*> pdeResidualU.data,
                                                        <double*> dpdeResidualU_dp.data,
                                                        <double*> dpdeResidualU_du.data,
                                                        <double*> pdeResidualV.data,
                                                        <double*> dpdeResidualV_dp.data,
                                                        <double*> dpdeResidualV_dv.data,
                                                        <double*> pdeResidualW.data,
                                                        <double*> dpdeResidualW_dp.data,
                                                        <double*> dpdeResidualW_dw.data,
                                                        <double*> subgridErrorP.data,
                                                        <double*> dsubgridErrorP_du.data,
                                                        <double*> dsubgridErrorP_dv.data,
                                                        <double*> dsubgridErrorP_dw.data,
                                                        <double*> subgridErrorU.data,
                                                        <double*> dsubgridErrorU_dp.data,
                                                        <double*> dsubgridErrorU_du.data,
                                                        <double*> subgridErrorV.data,
                                                        <double*> dsubgridErrorV_dp.data,
                                                        <double*> dsubgridErrorV_dv.data,
                                                        <double*> subgridErrorW.data,
                                                        <double*> dsubgridErrorW_dp.data,
                                                        <double*> dsubgridErrorW_dw.data)
def calculateSubgridErrorNavierStokes2D_GLS_tau(double  hFactor,
                                                 np.ndarray elementDiameter,
                                                 np.ndarray dmt,
                                                 np.ndarray dm,
                                                 np.ndarray f,
                                                 np.ndarray a,
                                                 np.ndarray tau0,
                                                 np.ndarray tau1,
                                                 np.ndarray cfl):
    ccalculateSubgridErrorNavierStokes2D_GLS_tau(f.shape[0],
                                                f.shape[1],
                                                f.shape[2],
                                                hFactor,
                                                <double*> elementDiameter.data,
                                                <double*> dmt.data,
                                                <double*> dm.data,
                                                <double*> f.data,
                                                <double*> a.data,
                                                <double*> tau0.data,
                                                <double*> tau1.data,
                                                <double*> cfl.data)
def calculateSubgridErrorNavierStokes2D_GLS_tau_sd(double  hFactor,
                                                 np.ndarray elementDiameter,
                                                 np.ndarray dmt,
                                                 np.ndarray dm,
                                                 np.ndarray f,
                                                 np.ndarray a,
                                                 np.ndarray tau0,
                                                 np.ndarray tau1,
                                                 np.ndarray cfl):
    ccalculateSubgridErrorNavierStokes2D_GLS_tau_sd(f.shape[0],
                                                f.shape[1],
                                                f.shape[2],
                                                hFactor,
                                                <double*> elementDiameter.data,
                                                <double*> dmt.data,
                                                <double*> dm.data,
                                                <double*> f.data,
                                                <double*> a.data,
                                                <double*> tau0.data,
                                                <double*> tau1.data,
                                                <double*> cfl.data)
def calculateSubgridErrorNavierStokes2D_generic_tau(np.ndarray inverseJ,
                                                     np.ndarray dmt,
                                                     np.ndarray dm,
                                                     np.ndarray f,
                                                     np.ndarray a,
                                                     np.ndarray tau0,
                                                     np.ndarray tau1,
                                                     np.ndarray cfl):
    ccalculateSubgridErrorNavierStokes2D_generic_tau(f.shape[0],
                                                    f.shape[1],
                                                    f.shape[2],
                                                    <double*> inverseJ.data,
                                                    <double*> dmt.data,
                                                    <double*> dm.data,
                                                    <double*> f.data,
                                                    <double*> a.data,
                                                    <double*> tau0.data,
                                                    <double*> tau1.data,
                                                    <double*> cfl.data)
def calculateSubgridErrorNavierStokes2D_generic_tau_sd(np.ndarray inverseJ,
                                                     np.ndarray dmt,
                                                     np.ndarray dm,
                                                     np.ndarray f,
                                                     np.ndarray a,
                                                     np.ndarray tau0,
                                                     np.ndarray tau1,
                                                     np.ndarray cfl):
    ccalculateSubgridErrorNavierStokes2D_generic_tau_sd(f.shape[0],
                                                    f.shape[1],
                                                    f.shape[2],
                                                    <double*> inverseJ.data,
                                                    <double*> dmt.data,
                                                    <double*> dm.data,
                                                    <double*> f.data,
                                                    <double*> a.data,
                                                    <double*> tau0.data,
                                                    <double*> tau1.data,
                                                    <double*> cfl.data)
def calculateSubgridErrorNavierStokes2D_generic_withBodyForce_tau(np.ndarray inverseJ,
                                                    np.ndarray dmt,
                                                    np.ndarray dm,
                                                    np.ndarray f,
                                                    np.ndarray a,
                                                    np.ndarray dr,
                                                    np.ndarray tau0,
                                                    np.ndarray tau1,
                                                    np.ndarray cfl):
    ccalculateSubgridErrorNavierStokes2D_generic_withBodyForce_tau(f.shape[0],
                                                    f.shape[1],
                                                    f.shape[2],
                                                    <double*> inverseJ.data,
                                                    <double*> dmt.data,
                                                    <double*> dm.data,
                                                    <double*> f.data,
                                                    <double*> a.data,
                                                    <double*> dr.data,
                                                    <double*> tau0.data,
                                                    <double*> tau1.data,
                                                    <double*> cfl.data)
def calculateSubgridErrorNavierStokes2D_generic_withBodyForce_tau_sd(np.ndarray inverseJ,
                                   np.ndarray dmt,
                                   np.ndarray dm,
                                   np.ndarray f,
                                   np.ndarray a,
                                   np.ndarray dr,
                                   np.ndarray tau0,
                                   np.ndarray tau1,
                                   np.ndarray cfl):
    ccalculateSubgridErrorNavierStokes2D_generic_withBodyForce_tau_sd(f.shape[0],
                                                    f.shape[1],
                                                    f.shape[2],
                                                    <double*> inverseJ.data,
                                                    <double*> dmt.data,
                                                    <double*> dm.data,
                                                    <double*> f.data,
                                                    <double*> a.data,
                                                    <double*> dr.data,
                                                    <double*> tau0.data,
                                                    <double*> tau1.data,
                                                    <double*> cfl.data)
def calculateSubgridErrorNavierStokes2D_GLS_tauRes(np.ndarray tau0,
                                                    np.ndarray tau1,
                                                    np.ndarray pdeResidualP,
                                                    np.ndarray dpdeResidualP_du,
                                                    np.ndarray dpdeResidualP_dv,
                                                    np.ndarray pdeResidualU,
                                                    np.ndarray dpdeResidualU_dp,
                                                    np.ndarray dpdeResidualU_du,
                                                    np.ndarray dpdeResidualU_dv,
                                                    np.ndarray pdeResidualV,
                                                    np.ndarray dpdeResidualV_dp,
                                                    np.ndarray dpdeResidualV_du,
                                                    np.ndarray dpdeResidualV_dv,
                                                    np.ndarray subgridErrorP,
                                                    np.ndarray dsubgridErrorP_du,
                                                    np.ndarray dsubgridErrorP_dv,
                                                    np.ndarray subgridErrorU,
                                                    np.ndarray dsubgridErrorU_dp,
                                                    np.ndarray dsubgridErrorU_du,
                                                    np.ndarray dsubgridErrorU_dv,
                                                    np.ndarray subgridErrorV,
                                                    np.ndarray dsubgridErrorV_dp,
                                                    np.ndarray dsubgridErrorV_du,
                                                    np.ndarray dsubgridErrorV_dv):
    ccalculateSubgridErrorNavierStokes2D_GLS_tauRes(dsubgridErrorP_du.shape[0],
                                                    dsubgridErrorP_du.shape[1],
                                                    dsubgridErrorP_du.shape[2],
                                                    2,
                                                    <double*> tau0.data,
                                                    <double*> tau1.data,
                                                    <double*> pdeResidualP.data,
                                                    <double*> dpdeResidualP_du.data,
                                                    <double*> dpdeResidualP_dv.data,
                                                    <double*> pdeResidualU.data,
                                                    <double*> dpdeResidualU_dp.data,
                                                    <double*> dpdeResidualU_du.data,
                                                    <double*> dpdeResidualU_dv.data,
                                                    <double*> pdeResidualV.data,
                                                    <double*> dpdeResidualV_dp.data,
                                                    <double*> dpdeResidualV_du.data,
                                                    <double*> dpdeResidualV_dv.data,
                                                    <double*> subgridErrorP.data,
                                                    <double*> dsubgridErrorP_du.data,
                                                    <double*> dsubgridErrorP_dv.data,
                                                    <double*> subgridErrorU.data,
                                                    <double*> dsubgridErrorU_dp.data,
                                                    <double*> dsubgridErrorU_du.data,
                                                    <double*> dsubgridErrorU_dv.data,
                                                    <double*> subgridErrorV.data,
                                                    <double*> dsubgridErrorV_dp.data,
                                                    <double*> dsubgridErrorV_du.data,
                                                    <double*> dsubgridErrorV_dv.data)
def calculateSubgridErrorStokes_GLS_tau(np.ndarray elementDiameter,
                                         np.ndarray dH,
                                         np.ndarray a,
                                         np.ndarray tau0,
                                         np.ndarray tau1):
    ccalculateSubgridErrorStokes_GLS_tau(dH.shape[0],
                                        dH.shape[1],
                                        dH.shape[2],
                                        <double*> elementDiameter.data,
                                        <double*> dH.data,
                                        <double*> a.data,
                                        <double*> tau0.data,
                                        <double*> tau1.data)
def calculateSubgridErrorStokes_GLS_tau_sd(np.ndarray elementDiameter,
                                            np.ndarray dH,
                                            np.ndarray a,
                                            np.ndarray tau0,
                                            np.ndarray tau1):
    ccalculateSubgridErrorStokes_GLS_tau_sd(dH.shape[0],
                                            dH.shape[1],
                                            dH.shape[2],
                                            <double*> elementDiameter.data,
                                            <double*> dH.data,
                                            <double*> a.data,
                                            <double*> tau0.data,
                                            <double*> tau1.data)
def calculateSubgridErrorStokes2D_GLS_tauRes(np.ndarray tau0,
                                              np.ndarray tau1,
                                              np.ndarray pdeResidualP,
                                              np.ndarray dpdeResidualP_du,
                                              np.ndarray dpdeResidualP_dv,
                                              np.ndarray pdeResidualU,
                                              np.ndarray dpdeResidualU_dp,
                                              np.ndarray dpdeResidualU_du,
                                              np.ndarray pdeResidualV,
                                              np.ndarray dpdeResidualV_dp,
                                              np.ndarray dpdeResidualV_dv,
                                              np.ndarray subgridErrorP,
                                              np.ndarray dsubgridErrorP_du,
                                              np.ndarray dsubgridErrorP_dv,
                                              np.ndarray subgridErrorU,
                                              np.ndarray dsubgridErrorU_dp,
                                              np.ndarray dsubgridErrorU_du,
                                              np.ndarray subgridErrorV,
                                              np.ndarray dsubgridErrorV_dp,
                                              np.ndarray dsubgridErrorV_dv):
    ccalculateSubgridErrorStokes2D_GLS_tauRes(dsubgridErrorP_du.shape[0],
                                            dsubgridErrorP_du.shape[1],
                                            dsubgridErrorP_du.shape[2],
                                            2,
                                            <double*> tau0.data,
                                            <double*> tau1.data,
                                            <double*> pdeResidualP.data,
                                            <double*> dpdeResidualP_du.data,
                                            <double*> dpdeResidualP_dv.data,
                                            <double*> pdeResidualU.data,
                                            <double*> dpdeResidualU_dp.data,
                                            <double*> dpdeResidualU_du.data,
                                            <double*> pdeResidualV.data,
                                            <double*> dpdeResidualV_dp.data,
                                            <double*> dpdeResidualV_dv.data,
                                            <double*> subgridErrorP.data,
                                            <double*> dsubgridErrorP_du.data,
                                            <double*> dsubgridErrorP_dv.data,
                                            <double*> subgridErrorU.data,
                                            <double*> dsubgridErrorU_dp.data,
                                            <double*> dsubgridErrorU_du.data,
                                            <double*> subgridErrorV.data,
                                            <double*> dsubgridErrorV_dp.data,
                                            <double*> dsubgridErrorV_dv.data)
def calculateSubgridErrorStokes3D_GLS_tauRes(np.ndarray tau0,
                                            np.ndarray tau1,
                                            np.ndarray pdeResidualP,
                                            np.ndarray dpdeResidualP_du,
                                            np.ndarray dpdeResidualP_dv,
                                            np.ndarray dpdeResidualP_dw,
                                            np.ndarray pdeResidualU,
                                            np.ndarray dpdeResidualU_dp,
                                            np.ndarray dpdeResidualU_du,
                                            np.ndarray pdeResidualV,
                                            np.ndarray dpdeResidualV_dp,
                                            np.ndarray dpdeResidualV_dv,
                                            np.ndarray pdeResidualW,
                                            np.ndarray dpdeResidualW_dp,
                                            np.ndarray dpdeResidualW_dw,
                                            np.ndarray subgridErrorP,
                                            np.ndarray dsubgridErrorP_du,
                                            np.ndarray dsubgridErrorP_dv,
                                            np.ndarray dsubgridErrorP_dw,
                                            np.ndarray subgridErrorU,
                                            np.ndarray dsubgridErrorU_dp,
                                            np.ndarray dsubgridErrorU_du,
                                            np.ndarray subgridErrorV,
                                            np.ndarray dsubgridErrorV_dp,
                                            np.ndarray dsubgridErrorV_dv,
                                            np.ndarray subgridErrorW,
                                            np.ndarray dsubgridErrorW_dp,
                                            np.ndarray dsubgridErrorW_dw):
    ccalculateSubgridErrorStokes3D_GLS_tauRes(dsubgridErrorP_du.shape[0],
                                            dsubgridErrorP_du.shape[1],
                                            dsubgridErrorP_du.shape[2],
                                            3,
                                            <double*> tau0.data,
                                            <double*> tau1.data,
                                            <double*> pdeResidualP.data,
                                            <double*> dpdeResidualP_du.data,
                                            <double*> dpdeResidualP_dv.data,
                                            <double*> dpdeResidualP_dw.data,
                                            <double*> pdeResidualU.data,
                                            <double*> dpdeResidualU_dp.data,
                                            <double*> dpdeResidualU_du.data,
                                            <double*> pdeResidualV.data,
                                            <double*> dpdeResidualV_dp.data,
                                            <double*> dpdeResidualV_dv.data,
                                            <double*> pdeResidualW.data,
                                            <double*> dpdeResidualW_dp.data,
                                            <double*> dpdeResidualW_dw.data,
                                            <double*> subgridErrorP.data,
                                            <double*> dsubgridErrorP_du.data,
                                            <double*> dsubgridErrorP_dv.data,
                                            <double*> dsubgridErrorP_dw.data,
                                            <double*> subgridErrorU.data,
                                            <double*> dsubgridErrorU_dp.data,
                                            <double*> dsubgridErrorU_du.data,
                                            <double*> subgridErrorV.data,
                                            <double*> dsubgridErrorV_dp.data,
                                            <double*> dsubgridErrorV_dv.data,
                                            <double*> subgridErrorW.data,
                                            <double*> dsubgridErrorW_dp.data,
                                            <double*> dsubgridErrorW_dw.data)
def calculateSubgridErrorNavierStokes3D_GLS_tauRes(np.ndarray tau0,
                                                    np.ndarray tau1,
                                                    np.ndarray pdeResidualP,
                                                    np.ndarray dpdeResidualP_du,
                                                    np.ndarray dpdeResidualP_dv,
                                                    np.ndarray dpdeResidualP_dw,
                                                    np.ndarray pdeResidualU,
                                                    np.ndarray dpdeResidualU_dp,
                                                    np.ndarray dpdeResidualU_du,
                                                    np.ndarray dpdeResidualU_dv,
                                                    np.ndarray dpdeResidualU_dw,
                                                    np.ndarray pdeResidualV,
                                                    np.ndarray dpdeResidualV_dp,
                                                    np.ndarray dpdeResidualV_du,
                                                    np.ndarray dpdeResidualV_dv,
                                                    np.ndarray dpdeResidualV_dw,
                                                    np.ndarray pdeResidualW,
                                                    np.ndarray dpdeResidualW_dp,
                                                    np.ndarray dpdeResidualW_du,
                                                    np.ndarray dpdeResidualW_dv,
                                                    np.ndarray dpdeResidualW_dw,
                                                    np.ndarray subgridErrorP,
                                                    np.ndarray dsubgridErrorP_du,
                                                    np.ndarray dsubgridErrorP_dv,
                                                    np.ndarray dsubgridErrorP_dw,
                                                    np.ndarray subgridErrorU,
                                                    np.ndarray dsubgridErrorU_dp,
                                                    np.ndarray dsubgridErrorU_du,
                                                    np.ndarray dsubgridErrorU_dv,
                                                    np.ndarray dsubgridErrorU_dw,
                                                    np.ndarray subgridErrorV,
                                                    np.ndarray dsubgridErrorV_dp,
                                                    np.ndarray dsubgridErrorV_du,
                                                    np.ndarray dsubgridErrorV_dv,
                                                    np.ndarray dsubgridErrorV_dw,
                                                    np.ndarray subgridErrorW,
                                                    np.ndarray dsubgridErrorW_dp,
                                                    np.ndarray dsubgridErrorW_du,
                                                    np.ndarray dsubgridErrorW_dv,
                                                    np.ndarray dsubgridErrorW_dw):
    ccalculateSubgridErrorNavierStokes3D_GLS_tauRes(dsubgridErrorP_du.shape[0],
                                                    dsubgridErrorP_du.shape[1],
                                                    dsubgridErrorP_du.shape[2],
                                                    3,
                                                    <double*> tau0.data,
                                                    <double*> tau1.data,
                                                    <double*> pdeResidualP.data,
                                                    <double*> dpdeResidualP_du.data,
                                                    <double*> dpdeResidualP_dv.data,
                                                    <double*> dpdeResidualP_dw.data,
                                                    <double*> pdeResidualU.data,
                                                    <double*> dpdeResidualU_dp.data,
                                                    <double*> dpdeResidualU_du.data,
                                                    <double*> dpdeResidualU_dv.data,
                                                    <double*> dpdeResidualU_dw.data,
                                                    <double*> pdeResidualV.data,
                                                    <double*> dpdeResidualV_dp.data,
                                                    <double*> dpdeResidualV_du.data,
                                                    <double*> dpdeResidualV_dv.data,
                                                    <double*> dpdeResidualV_dw.data,
                                                    <double*> pdeResidualW.data,
                                                    <double*> dpdeResidualW_dp.data,
                                                    <double*> dpdeResidualW_du.data,
                                                    <double*> dpdeResidualW_dv.data,
                                                    <double*> dpdeResidualW_dw.data,
                                                    <double*> subgridErrorP.data,
                                                    <double*> dsubgridErrorP_du.data,
                                                    <double*> dsubgridErrorP_dv.data,
                                                    <double*> dsubgridErrorP_dw.data,
                                                    <double*> subgridErrorU.data,
                                                    <double*> dsubgridErrorU_dp.data,
                                                    <double*> dsubgridErrorU_du.data,
                                                    <double*> dsubgridErrorU_dv.data,
                                                    <double*> dsubgridErrorU_dw.data,
                                                    <double*> subgridErrorV.data,
                                                    <double*> dsubgridErrorV_dp.data,
                                                    <double*> dsubgridErrorV_du.data,
                                                    <double*> dsubgridErrorV_dv.data,
                                                    <double*> dsubgridErrorV_dw.data,
                                                    <double*> subgridErrorW.data,
                                                    <double*> dsubgridErrorW_dp.data,
                                                    <double*> dsubgridErrorW_du.data,
                                                    <double*> dsubgridErrorW_dv.data,
                                                    <double*> dsubgridErrorW_dw.data)
def calculateSubgridErrorNavierStokes3D_GLS_velocity_pressure(np.ndarray elementDiameter,
                                                               np.ndarray dm,
                                                               np.ndarray f,
                                                               np.ndarray a,
                                                               np.ndarray pdeResidualP,
                                                               np.ndarray dpdeResidualP_du,
                                                               np.ndarray dpdeResidualP_dv,
                                                               np.ndarray dpdeResidualP_dw,
                                                               np.ndarray pdeResidualU,
                                                               np.ndarray dpdeResidualU_dp,
                                                               np.ndarray dpdeResidualU_du,
                                                               np.ndarray pdeResidualV,
                                                               np.ndarray dpdeResidualV_dp,
                                                               np.ndarray dpdeResidualV_dv,
                                                               np.ndarray pdeResidualW,
                                                               np.ndarray dpdeResidualW_dp,
                                                               np.ndarray dpdeResidualW_dw,
                                                               np.ndarray subgridErrorP,
                                                               np.ndarray dsubgridErrorP_du,
                                                               np.ndarray dsubgridErrorP_dv,
                                                               np.ndarray dsubgridErrorP_dw,
                                                               np.ndarray subgridErrorU,
                                                               np.ndarray dsubgridErrorU_dp,
                                                               np.ndarray dsubgridErrorU_du,
                                                               np.ndarray subgridErrorV,
                                                               np.ndarray dsubgridErrorV_dp,
                                                               np.ndarray dsubgridErrorV_dv,
                                                               np.ndarray subgridErrorW,
                                                               np.ndarray dsubgridErrorW_dp,
                                                               np.ndarray dsubgridErrorW_dw):
    ccalculateSubgridErrorNavierStokes3D_GLS_velocity_pressure(dsubgridErrorP_du.shape[0],
                                                            dsubgridErrorP_du.shape[1],
                                                            dsubgridErrorP_du.shape[2],
                                                            3,
                                                            <double*> elementDiameter.data,
                                                            <double*> dm.data,
                                                            <double*> f.data,
                                                            <double*> a.data,
                                                            <double*> pdeResidualP.data,
                                                            <double*> dpdeResidualP_du.data,
                                                            <double*> dpdeResidualP_dv.data,
                                                            <double*> dpdeResidualP_dw.data,
                                                            <double*> pdeResidualU.data,
                                                            <double*> dpdeResidualU_dp.data,
                                                            <double*> dpdeResidualU_du.data,
                                                            <double*> pdeResidualV.data,
                                                            <double*> dpdeResidualV_dp.data,
                                                            <double*> dpdeResidualV_dv.data,
                                                            <double*> pdeResidualW.data,
                                                            <double*> dpdeResidualW_dp.data,
                                                            <double*> dpdeResidualW_dw.data,
                                                            <double*> subgridErrorP.data,
                                                            <double*> dsubgridErrorP_du.data,
                                                            <double*> dsubgridErrorP_dv.data,
                                                            <double*> dsubgridErrorP_dw.data,
                                                            <double*> subgridErrorU.data,
                                                            <double*> dsubgridErrorU_dp.data,
                                                            <double*> dsubgridErrorU_du.data,
                                                            <double*> subgridErrorV.data,
                                                            <double*> dsubgridErrorV_dp.data,
                                                            <double*> dsubgridErrorV_dv.data,
                                                            <double*> subgridErrorW.data,
                                                            <double*> dsubgridErrorW_dp.data,
                                                            <double*> dsubgridErrorW_dw.data)
def calculateSubgridErrorNavierStokes3D_GLS_velocity_pressure_sd(np.ndarray elementDiameter,
                                                               np.ndarray dm,
                                                               np.ndarray f,
                                                               np.ndarray a,
                                                               np.ndarray pdeResidualP,
                                                               np.ndarray dpdeResidualP_du,
                                                               np.ndarray dpdeResidualP_dv,
                                                               np.ndarray dpdeResidualP_dw,
                                                               np.ndarray pdeResidualU,
                                                               np.ndarray dpdeResidualU_dp,
                                                               np.ndarray dpdeResidualU_du,
                                                               np.ndarray pdeResidualV,
                                                               np.ndarray dpdeResidualV_dp,
                                                               np.ndarray dpdeResidualV_dv,
                                                               np.ndarray pdeResidualW,
                                                               np.ndarray dpdeResidualW_dp,
                                                               np.ndarray dpdeResidualW_dw,
                                                               np.ndarray subgridErrorP,
                                                               np.ndarray dsubgridErrorP_du,
                                                               np.ndarray dsubgridErrorP_dv,
                                                               np.ndarray dsubgridErrorP_dw,
                                                               np.ndarray subgridErrorU,
                                                               np.ndarray dsubgridErrorU_dp,
                                                               np.ndarray dsubgridErrorU_du,
                                                               np.ndarray subgridErrorV,
                                                               np.ndarray dsubgridErrorV_dp,
                                                               np.ndarray dsubgridErrorV_dv,
                                                               np.ndarray subgridErrorW,
                                                               np.ndarray dsubgridErrorW_dp,
                                                               np.ndarray dsubgridErrorW_dw):
    ccalculateSubgridErrorNavierStokes3D_GLS_velocity_pressure_sd(dsubgridErrorP_du.shape[0],
                                                                dsubgridErrorP_du.shape[1],
                                                                dsubgridErrorP_du.shape[2],
                                                                3,
                                                                <double*> elementDiameter.data,
                                                                <double*> dm.data,
                                                                <double*> f.data,
                                                                <double*> a.data,
                                                                <double*> pdeResidualP.data,
                                                                <double*> dpdeResidualP_du.data,
                                                                <double*> dpdeResidualP_dv.data,
                                                                <double*> dpdeResidualP_dw.data,
                                                                <double*> pdeResidualU.data,
                                                                <double*> dpdeResidualU_dp.data,
                                                                <double*> dpdeResidualU_du.data,
                                                                <double*> pdeResidualV.data,
                                                                <double*> dpdeResidualV_dp.data,
                                                                <double*> dpdeResidualV_dv.data,
                                                                <double*> pdeResidualW.data,
                                                                <double*> dpdeResidualW_dp.data,
                                                                <double*> dpdeResidualW_dw.data,
                                                                <double*> subgridErrorP.data,
                                                                <double*> dsubgridErrorP_du.data,
                                                                <double*> dsubgridErrorP_dv.data,
                                                                <double*> dsubgridErrorP_dw.data,
                                                                <double*> subgridErrorU.data,
                                                                <double*> dsubgridErrorU_dp.data,
                                                                <double*> dsubgridErrorU_du.data,
                                                                <double*> subgridErrorV.data,
                                                                <double*> dsubgridErrorV_dp.data,
                                                                <double*> dsubgridErrorV_dv.data,
                                                                <double*> subgridErrorW.data,
                                                                <double*> dsubgridErrorW_dp.data,
                                                                <double*> dsubgridErrorW_dw.data)
def calculateSubgridErrorStokes2D_1(np.ndarray elementDiameter,
                                     np.ndarray u,
                                     np.ndarray v,
                                     np.ndarray a,
                                     np.ndarray pdeResidualP,
                                     np.ndarray dpdeResidualP_du,
                                     np.ndarray dpdeResidualP_dv,
                                     np.ndarray pdeResidualU,
                                     np.ndarray dpdeResidualU_dp,
                                     np.ndarray dpdeResidualU_du,
                                     np.ndarray pdeResidualV,
                                     np.ndarray dpdeResidualV_dp,
                                     np.ndarray dpdeResidualV_dv,
                                     np.ndarray subgridErrorP,
                                     np.ndarray dsubgridErrorP_dp,
                                     np.ndarray dsubgridErrorP_du,
                                     np.ndarray dsubgridErrorP_dv,
                                     np.ndarray subgridErrorU,
                                     np.ndarray dsubgridErrorU_dp,
                                     np.ndarray dsubgridErrorU_du,
                                     np.ndarray dsubgridErrorU_dv,
                                     np.ndarray subgridErrorV,
                                     np.ndarray dsubgridErrorV_dp,
                                     np.ndarray dsubgridErrorV_du,
                                     np.ndarray dsubgridErrorV_dv):
    ccalculateSubgridErrorStokes2D_1(dsubgridErrorP_du.shape[0],
                                    dsubgridErrorP_du.shape[1],
                                    dsubgridErrorP_du.shape[2],
                                    2,
                                    <double*> elementDiameter.data,
                                    <double*> u.data,
                                    <double*> v.data,
                                    <double*> a.data,
                                    <double*> pdeResidualP.data,
                                    <double*> dpdeResidualP_du.data,
                                    <double*> dpdeResidualP_dv.data,
                                    <double*> pdeResidualU.data,
                                    <double*> dpdeResidualU_dp.data,
                                    <double*> dpdeResidualU_du.data,
                                    <double*> pdeResidualV.data,
                                    <double*> dpdeResidualV_dp.data,
                                    <double*> dpdeResidualV_dv.data,
                                    <double*> subgridErrorP.data,
                                    <double*> dsubgridErrorP_dp.data,
                                    <double*> dsubgridErrorP_du.data,
                                    <double*> dsubgridErrorP_dv.data,
                                    <double*> subgridErrorU.data,
                                    <double*> dsubgridErrorU_dp.data,
                                    <double*> dsubgridErrorU_du.data,
                                    <double*> dsubgridErrorU_dv.data,
                                    <double*> subgridErrorV.data,
                                    <double*> dsubgridErrorV_dp.data,
                                    <double*> dsubgridErrorV_du.data,
                                    <double*> dsubgridErrorV_dv.data)
def calculateSubgridErrorStokes2D_1_sd(np.ndarray elementDiameter,
                                     np.ndarray u,
                                     np.ndarray v,
                                     np.ndarray a,
                                     np.ndarray pdeResidualP,
                                     np.ndarray dpdeResidualP_du,
                                     np.ndarray dpdeResidualP_dv,
                                     np.ndarray pdeResidualU,
                                     np.ndarray dpdeResidualU_dp,
                                     np.ndarray dpdeResidualU_du,
                                     np.ndarray pdeResidualV,
                                     np.ndarray dpdeResidualV_dp,
                                     np.ndarray dpdeResidualV_dv,
                                     np.ndarray subgridErrorP,
                                     np.ndarray dsubgridErrorP_dp,
                                     np.ndarray dsubgridErrorP_du,
                                     np.ndarray dsubgridErrorP_dv,
                                     np.ndarray subgridErrorU,
                                     np.ndarray dsubgridErrorU_dp,
                                     np.ndarray dsubgridErrorU_du,
                                     np.ndarray dsubgridErrorU_dv,
                                     np.ndarray subgridErrorV,
                                     np.ndarray dsubgridErrorV_dp,
                                     np.ndarray dsubgridErrorV_du,
                                     np.ndarray dsubgridErrorV_dv):
    ccalculateSubgridErrorStokes2D_1_sd(dsubgridErrorP_du.shape[0],
                                    dsubgridErrorP_du.shape[1],
                                    dsubgridErrorP_du.shape[2],
                                    2,
                                    <double*> elementDiameter.data,
                                    <double*> u.data,
                                    <double*> v.data,
                                    <double*> a.data,
                                    <double*> pdeResidualP.data,
                                    <double*> dpdeResidualP_du.data,
                                    <double*> dpdeResidualP_dv.data,
                                    <double*> pdeResidualU.data,
                                    <double*> dpdeResidualU_dp.data,
                                    <double*> dpdeResidualU_du.data,
                                    <double*> pdeResidualV.data,
                                    <double*> dpdeResidualV_dp.data,
                                    <double*> dpdeResidualV_dv.data,
                                    <double*> subgridErrorP.data,
                                    <double*> dsubgridErrorP_dp.data,
                                    <double*> dsubgridErrorP_du.data,
                                    <double*> dsubgridErrorP_dv.data,
                                    <double*> subgridErrorU.data,
                                    <double*> dsubgridErrorU_dp.data,
                                    <double*> dsubgridErrorU_du.data,
                                    <double*> dsubgridErrorU_dv.data,
                                    <double*> subgridErrorV.data,
                                    <double*> dsubgridErrorV_dp.data,
                                    <double*> dsubgridErrorV_du.data,
                                    <double*> dsubgridErrorV_dv.data)
def calculateSubgridErrorShallowWater1D(double g,
                                         np.ndarray elementDiameter,
                                         np.ndarray h,
                                         np.ndarray hu,
                                         np.ndarray cfl_1,
                                         np.ndarray cfl_2):
    ccalculateSubgridErrorShallowWater1D(h.shape[0],
                                        h.shape[1],
                                        g,
                                        <double*> elementDiameter.data,
                                        <double*> h.data,
                                        <double*> hu.data,
                                        <double*> cfl_1.data,
                                        <double*> cfl_2.data)
def calculateSubgridErrorShallowWater2D(double g,
                                         np.ndarray elementDiameter,
                                         np.ndarray h,
                                         np.ndarray hu,
                                         np.ndarray hv,
                                         np.ndarray cfl_1,
                                         np.ndarray cfl_2,
                                         np.ndarray cfl_3):
    ccalculateSubgridErrorShallowWater2D(h.shape[0],
                                        h.shape[1],
                                        g,
                                        <double*> elementDiameter.data,
                                        <double*> h.data,
                                        <double*> hu.data,
                                        <double*> hv.data,
                                        <double*> cfl_1.data,
                                        <double*> cfl_2.data,
                                        <double*> cfl_3.data)
def calculateSubgridError_Harari_tau_sd(int nSpace,
                                        double dt,
                                        np.ndarray rowptr,
                                        np.ndarray colind,
                                        np.ndarray elementDiameter,
                                        np.ndarray a,
                                        np.ndarray tau):
    ccalculateSubgridError_Harari_tau_sd(tau.shape[0],
                                        tau.shape[1],
                                        nSpace,
                                        dt,
                                        <int*> rowptr.data,
                                        <int*> colind.data,
                                        <double*> elementDiameter.data,
                                        <double*> a.data,
                                        <double*> tau.data)
def calculateSubgridErrorGradient_tauRes(np.ndarray tau_gradient,
                                        np.ndarray grad_pdeResidual,
                                        np.ndarray grad_subgridError):
    ccalculateSubgridErrorGradient_tauRes(grad_subgridError.shape[0],
                                        grad_subgridError.shape[1],
                                        grad_subgridError.shape[2],
                                        <double*> tau_gradient.data,
                                        <double*> grad_pdeResidual.data,
                                        <double*> grad_subgridError.data)
def calculateSubgridError_ADR_Sangalli_tau_sd(np.ndarray rowptr,
                                            np.ndarray colind,
                                            np.ndarray inverseJ,
                                            np.ndarray dmt,
                                            np.ndarray df,
                                            np.ndarray a,
                                            np.ndarray da,
                                            np.ndarray grad_phi,
                                            np.ndarray dphi,
                                            np.ndarray dr,
                                            np.ndarray pe,
                                            np.ndarray cfl,
                                            np.ndarray tau,
                                            np.ndarray tau_gradient):
    ccalculateSubgridError_ADR_Sangalli_tau_sd(df.shape[0],
                                            df.shape[1],
                                            df.shape[2],
                                            <int*> rowptr.data,
                                            <int*> colind.data,
                                            <double*> inverseJ.data,
                                            <double*> dmt.data,
                                            <double*> df.data,
                                            <double*> a.data,
                                            <double*> da.data,
                                            <double*> grad_phi.data,
                                            <double*> dphi.data,
                                            <double*> dr.data,
                                            <double*> pe.data,
                                            <double*> cfl.data,
                                            <double*> tau.data,
                                            <double*> tau_gradient.data)
